program d3_plus; (* 3D 0.4 *)

{define test}
{define collision}
{ simboli riconosciuti dal compilatore: 			}
{	test  abilita il test temporale				}
{	collision  abilita il controllo di collisione	        }

{ Rev 0.4                                                       }
{ modifiche:							}
{    10/1995   Aggiunti i comandi ^S e ^L per salvare/ripristinare la posizione }
{              i comandi ^R e ^P per registrare/rivedere un percorso }
{    11/1995   Aggiunto il controllo di collisione              }
{              Nuovi parametri del comando /16 /256 /BW         }

uses crt,drivers,graph3d,data3d,file3d {$ifdef test},timer{$endif};

{$B-}  { BOOLEAN SHORT CIRCUIT }

const phistep=0.1;  { step della direzione dell'osservatore  }
      kbShift=kbLeftShift + kbRightShift;

var change,quit:boolean;
    a:pnode;
    linstep:real;
    log:boolean;logf:text;
    fname:string;
    fault:boolean;
    i:integer;cmode:tmode;
    xo,yo,zo:real; { posizione dell' osservatore }
    phi:real; { direzione di visione in radianti }

procedure svuota_buffer;
begin
inline($FA); { disable interrupts }
MemW[0:$41A]:=MemW[0:$41C];
inline($FB); { enable interrupts }
end; { of svuota_buffer }

procedure save_pos;
var f:text;
begin
  assign(f,'save_pos.3d');
  rewrite(f);
  writeln(f,phi,' ',xo,' ',yo,' ',zo);
  close(f);
end;

procedure restore_pos;
var f:text;
begin
  assign(f,'save_pos.3d');
(*$I-*)
  reset(f);
  if IOResult <> 0
  then exit;
(*$I+*)
  readln(f,phi,xo,yo,zo);
  close(f);
end;

procedure OpenLog;
begin
  assign(logf,'log_pos.3d');
  rewrite(logf);
  writeln(logf,phi,' ',xo,' ',yo,' ',zo);
  log:=true;
end;

procedure CloseLog;
begin
  close(logf);
  log:=false;
end;

procedure PlayLog;
begin
  assign(logf,'log_pos.3d');
(*$I-*)
  reset(logf);
  if IOResult <> 0
  then exit;
(*$I+*)
  while not eof(logf)
  do begin
     readln(logf,phi,xo,yo,zo);
     show(a,xo,yo,zo,phi,1.57);
     end;
  close(logf);
end;

procedure UpdataOPosition(newxo,newyo,newzo:real;p:pnode);
var new:tpoint;
begin
{$ifdef collision}
  new.x:=newxo;
  new.y:=newyo;
  new.z:=newzo;
  if PointIsIncluded(new,p,phi) = nil
  then begin
{$endif}
         xo:=newxo;
         yo:=newyo;
         zo:=newzo;
         change:=true;
{$ifdef collision}
       end
  else linstep:=0;
{$endif}
end;

begin
fault:=false;
fname:='';
cmode:=color256;
for i:=1 to ParamCount
do if ParamStr(i) = '/16'
   then cmode:=color16
   else if ParamStr(i) = '/256'
        then cmode:=color256
        else if (ParamStr(i) = '/BW') or (ParamStr(i) = '/bw')
             then cmode:=gray64
             else if fname = ''
                  then fname:=ParamStr(i)
                  else fault:=true;
if fault or (fname = '')
then begin
     writeln('3D [/16 | /256 | /BW] filename');
     writeln;
     writeln('   /16:  16 colori     (VGA/EGA)');
     writeln('   /256: 256 colori    (accesso diretto alla memoria)');
     writeln('   /BW:  monocromatica (accesso diretto alla memoria)');
     halt(1);
     end;
a:=nil;
readfile(a,fname);
if a=nil
then begin
       writeln('The file does not contain objects');
       halt(1)
     end;
opengraph(cmode);
phi:=0;
xo:=1.2;
yo:=0;
zo:=1.1;
change:=true;
quit:=false;linstep:=0;
log:=false;
{$ifndef test}
repeat
if not change
then repeat until keypressed
else begin
     if log
     then writeln(logf,phi,' ',xo,' ',yo,' ',zo);
     show(a,xo,yo,zo,phi,1.57);
     end;
change:=false;
if keypressed
then case readkey of
     #0:begin
        change:=true;
        case readkey of
        'H':begin
            if GetShiftState and kbShift <> 0
            then UpdataOPosition(xo,yo,zo+0.2,a) (* shift+up arrow *)
            else linstep:=linstep+0.03;          (* up arrow       *)
	    end;
        'P':begin
            if GetShiftState and kbShift <> 0
            then UpdataOPosition(xo,yo,zo-0.2,a) (* shift+down arrow *)
            else linstep:=linstep-0.03;          (* down arrow       *)
	    end;
        'K':phi:=phi+phistep; {left arrow}
        'M':phi:=phi-phistep; {right arrow}
          else change:=false;
          end;
        end;
     ^S: save_pos;
     ^L: begin
         restore_pos;
         change:=true;
         end;
     ^R: if not log
         then OpenLog
         else {discard command};
     ^P: begin
         if log
         then CloseLog;
         PlayLog;
         end;
  #27:begin
	quit:=true;
	end;
end;{of case}
linstep:=0.95*linstep;
if abs(linstep)<0.01
then linstep:=0
else UpdataOPosition(xo+linstep*cos(phi),yo+linstep*sin(phi),zo,a);
svuota_buffer; { impedisce che il buffer di tastiera si possa riempire }
until quit;
closegraph;
{$else}
start;
repeat
show(a,xo,yo,zo,phi,1.57);
UpdataOPosition(xo-0.04,yo+0.04,zo+0.04,a);
phi:=phi-0.004;
until xo<-3;
closegraph;
time;
{$endif}
end.
