{ OCCORRE MIGLIORARE LA GESTIONE ERRORI SOTTO WINDOWS }

unit file3d; {PolyCx} (* 3D 0.45 *)
{$R+}

{  Data		Modifica						}
{									}
{  9/9/1990	SORT2 segnala la presenza di LOOPs di superfici		}
{ 12/94 Rev 0.1 : added *loop*                                          }
{ 12/94 Rev 0.2 : added *material*                                      }
{ 10/95 Rev 0.3 : added *PolyCx*,*linebuf*                              }
{ 11/95 Rev 0.4 : new format for file DAT(3DL)                          }
{ 12/97 Rev 0.45: adattamento a Windows. Vedi simbolo WINDOWS           }
{                 NOTA: Turbo Pascal for Windows non supporta break/continue}
interface

{$IFDEF WINDOWS}
uses strings, wobjects, wintypes,
     data3d,graph3d, prolinea;
{$ELSE}
uses data3d,graph3d,
     prolinea;
{$ENDIF}

const  maxidentifiers=128; (* numero massimo di identificatori *)
       zIdentBufSize=10*maxidentifiers; (* dimensione tavola identificatori *)

procedure readfile(var p:pnode;dat_name:string);


type tIdent=(null,keyword,unknown,objects,material,light,
             coordinate);
type tIdentTable=object(multi)
                  table:array[0..maxidentifiers-1]of
                              record
                                case tag:tIdent of
                                  light,objects,
                                  material,coordinate:(entityp:pointer);
                                  keyword:(value:integer);
                              end;
                  function add(s:string;tid:tIdent):word;
                  function search(s:string;var tid:tIdent):word;
                  procedure storevalue(s:string;tid:tIdent;value:integer);
                 end;
var  ident:tIdentTable;

implementation
const zDef=0;
      zIndexedLineSet=1;  (* keywords *)
      zIndexedFaceSet=2;
      zCoordIndex=3;
      zStructure=4;
      zGlobal=5;
      zTranslation=6;
      zRotation=7;
      zScale=8;
      zPoint=9;
      zMaterial=10;
      zColor=11;
      zSky=12;
      zGround=13;
      zDirection=14;
      zDirectionalLight=15;
      zAmbientColor=16;
      zDiffuseColor=17;
      zSpecularColor=18;
      zEmissiveColor=19;
      zTypeDef=20;
      zCoordinate3=21;
      zTransform=22;

var save_s:string;
    n_line_s:integer;
    nsupc:integer;

type tlinebuf=object(tLineBuffer) (*linebuf*)
                   f:text;
                   n_line:integer;
                   currentState:tState; (*state*)
                   currentMaterial:pMaterial;
                   currentPointArray:pPointArray;
                   procedure Flush(var s:string;var eof:boolean);virtual;
                   procedure GetRealNumber(var x:real);
                   procedure Get3RealNumber(var x,y,z:real);
                   function check(s:string):boolean;
                   procedure Assert(s:string);
                   constructor Init(name:string);
                   destructor Done;
                   (* the following procedures were added later *)
                   function GetEntity(var entityp:pointer;var value:integer):tIdent;
                   function fetch_object:pnode;
                   function fetch_directLight:pLight;
                   function fetch_material:pMaterial;
                   function fetch_coordinate:pPointArray;
                   procedure fetch_transform;
                   function fetch_indexedset(tipo1:ttypenode):pnode;
              end;

{$IFDEF WINDOWS}
procedure error(s:string);
var sz: array[0..255] of char;
begin
  StrPCopy(sz, s);
  MessageBox(Application^.MainWindow^.HWindow, sz, nil, MB_Ok);
  Application^.Done;
{
if n_line_s <> 0
then begin
     writeln('Fatal error near line ',n_line_s,' :',s);
     writeln(save_s);
     end
else writeln('Fatal error:',s);
}
Halt;
end; { of error }
{$ELSE}
procedure error(s:string);
begin
if graphic=true
then closegraph;
if n_line_s <> 0
then begin
     writeln('Fatal error near line ',n_line_s,' :',s);
     writeln(save_s);
     end
else writeln('Fatal error:',s);
Halt;
end; { of error }
{$ENDIF}


(* ---------------- tLineBuf ----------------*)

procedure tlinebuf.Flush(var s:string;var eof:boolean); (*linebuf*)
begin
  eof:=system.eof(f);
  if eof
  then s:=''
  else begin
       readln(f,s);inc(n_line);
       save_s:=s;n_line_s:=n_line; (* used by <error> *)
       end;
end;

function tlinebuf.check(s:string):boolean;
var temp:string;
begin
  GetElement(temp);
  UpCases(temp);
  if s <> temp
  then begin
       ForgetElement;
       check:=false
       end
  else check:=true;
end;

procedure tlinebuf.Assert(s:string);
var temp:string;
begin
  GetElement(temp);
  UpCases(temp);
  if s <> temp
  then error(s+' expected');
end;

procedure tlinebuf.GetRealNumber(var x:real);
var s:string;
    code:integer;
begin
  GetElement(s);
  Val(s,x,code);
  if code <> 0
  then error('number expected');
end;

procedure tlinebuf.Get3RealNumber(var x,y,z:real);
var bracket:boolean;
begin
  bracket:=check('[');
  GetRealNumber(x);
  GetRealNumber(y);
  GetRealNumber(z);
  if bracket
  then assert(']');
end;

constructor tlinebuf.Init(name:string);
begin
tLineBuffer.Init;
n_line:=0;
assign(f,name);
{$I-}
reset(f);
if ioresult<>0
then error('Error opening file '+name);
{$I+}
  with CurrentState
  do begin
       with posizione
       do begin
            x:=0;
            y:=0;
            z:=0;
          end;
       scala:=1;
       cs:=1;sn:=0;
     end;
  currentMaterial:=defaultMaterial;
  currentPointArray:=nil;
end; { of open_file }

destructor tlinebuf.Done;
begin
  tLineBuffer.Done;
  close(f);
end;

(* ---------------- tIdentTable ----------------*)

procedure tIdentTable.storevalue(s:string;tid:tIdent;value:integer);
(* DA USARE SOLO CON <keyword> *)
begin
  table[add(s,tid)].value:=value;
end;

function tIdentTable.add(s:string;tid:tIdent):word;
var id:integer;
begin
  if multi.count >= maxidentifiers
  then error('too many identifiers');
  UpCases(s);
  if multi.search(s) = -1
  then begin
       id:=multi.add(s);
       table[id].tag:=tid;
       add:=id;
       end
  else error('identifier already defined');
end;

function tIdentTable.search(s:string;var tid:tIdent):word;
var id:integer;
begin
  if length(s) = 0
  then begin
         tid:=null;
         exit;
       end;
  UpCases(s);
  id:=multi.search(s);
  if id=-1
  then begin
         tid:=unknown;
       end
  else begin
         tid:=table[id].tag;
         search:=id;
       end;
end;

(* ---------------- procedures ----------------*)


function analisi_poligono(pol:pclass;var normale:tpoint;var convesso:boolean;pmdl:pmodello):boolean;
{ Questa procedura determina se il poligono dato e' convesso o concavo	}
{ e calcola la normale al poligono					}

var Va,Vb,Vc,Vprev,Vx:pclass;
    a:tpoint;
    d,dmax:real;


begin
analisi_poligono:=false;
with pmdl^.PointArrayp^
do begin
  Vx:=pol;Vprev:=nil;
  Va:=nil;Vb:=nil;
  dmax:=0;
  (* search the most distant vertex, because it is convex *)
  while (Vx<>nil)
  do begin
     d:=distance(Vertici[pol^.vertice],Vertici[Vx^.vertice]);
     if d > dmax
     then begin
          dmax:=d;
          Vb:=Vx;
          Va:=Vprev;
          end;
     Vprev:=Vx;
     Vx:=Vx^.next;
     end;
  if Vb = nil
  then exit;
  if Va = nil
  then Va:=Vprev; (* in questo caso Vprev punta all'ultimo elemento *)
  if Vb^.next = nil
  then Vc:=pol
  else Vc:=Vb^.next;

  cross(Normale,Vertici[Vc^.vertice],Vertici[Vb^.vertice],Vertici[Va^.vertice]);
  if (Normale.x=0) and (Normale.y=0) and (Normale.z=0)
  then exit;
  versore(Normale);

  { ora e' possibile vedere quali vertici sono di convessita' e se il	}
  { poligono e' convesso o concavo }

  Va:=pol;
  convesso:=true;
  while (Va^.next^.next<>nil)
  do begin
     cross(a,Vertici[Va^.vertice],Vertici[Va^.next^.vertice],Vertici[Va^.next^.next^.vertice]);
     if dot(a,Normale)>0 { <--> concavita' di Va^.next }
     then begin
{	  Va^.next^.cont:=true;}
	  convesso:=false;
	  end;
     Va:=Va^.next;
     end;
   { ora opera il test sull'ultimo vertice }
   cross(a,Vertici[Va^.vertice],Vertici[Va^.next^.vertice],Vertici[pol^.vertice]);
   if dot(a,Normale)>0 { <--> concavita' di Va^.next }
   then begin
{	  Va^.next^.cont:=true;}
	  convesso:=false;
	end;
   Va:=Va^.next;
   { ora opera il test sul primo vertice }
   cross(a,Vertici[Va^.vertice],Vertici[pol^.vertice],Vertici[pol^.next^.vertice]);
   if dot(a,Normale)>0 { <--> concavita' di pol }
   then begin
{	  pol^.cont:=true;}
	  convesso:=false;
	end;
  end;
analisi_poligono:=true;
end; { of analisi_poligono }



    function IsVertex(v:word;s:pclass):boolean;
    (* questa funzione determina se il vertice <v> appartiene a <s> *)
    begin
      while (s<>nil)and(s^.vertice <> v)
      do s:=s^.next;
      IsVertex:=s<>nil;
    end;

procedure swap_sup(s1,s2:integer;pmdl:pmodello);
var tnorm:tpoint;
    tsup:pclass;
    tconv:boolean;
    tcol:pMaterial;
    tptr:pPolyCx;
{ scambia la posizione di due superfici nel modello MDL }
begin
if s1<>s2
then with pmdl^
do begin
   tnorm:=normali[s1];
   tsup:=superfici[s1];
   tconv:=convessa[s1];
   tcol:=colori[s1];
   tptr:=list_PolyCxs[s1];
   normali[s1]:=normali[s2];
   superfici[s1]:=superfici[s2];
   convessa[s1]:=convessa[s2];
   colori[s1]:=colori[s2];
   list_PolyCxs[s1]:=list_PolyCxs[s2];
   normali[s2]:=tnorm;
   superfici[s2]:=tsup;
   convessa[s2]:=tconv;
   colori[s2]:=tcol;
   list_PolyCxs[s2]:=tptr;
   end;
end; { of swap_sup }

function sup_copre(s1,s2:integer;pmdl:pmodello):boolean;
{ determina se 2 superfici s1 ed s2 dello stesso modello sono tali che	}
{ s1 puo' coprire s2							}

var p1,p2,first_p2:pclass;
    p1p2:tpoint;

   function intens(p:tpoint):real;
   begin
     intens:=abs(p.x)+abs(p.y)+abs(p.z);
   end;

begin
with pmdl^,pmdl^.PointArrayp^
do begin
   p1:=superfici[s1];
   first_p2:=superfici[s2];
   while (first_p2<>nil) and IsVertex(first_p2^.vertice,superfici[s1])
   do first_p2:=first_p2^.next;
   while p1<>nil
   do begin
      p2:=first_p2;
      while (p1<>nil) and IsVertex(p1^.vertice,superfici[s2])
      do p1:=p1^.next;
      if p1 <> nil
      then begin
           diff(p1p2,Vertici[p2^.Vertice],Vertici[p1^.Vertice]);
           if (dot(normali[s2],p1p2) < -intens(p1p2)*normal_factor)
           then begin
                while (p2<>nil)
                do begin
                   diff(p1p2,Vertici[p2^.Vertice],Vertici[p1^.Vertice]);
	           if dot(normali[s1],p1p2) < -intens(p1p2)*normal_factor
                   then begin
                        sup_copre:=true;
                        exit;
                        end;
	           p2:=p2^.next;
                   while (p2<>nil) and IsVertex(p2^.vertice,superfici[s1])
                   do p2:=p2^.next;
                   end;
	        end;
           p1:=p1^.next;
           end;
      end;
   end;
sup_copre:=false;
end; { of sup_copre }

procedure sort_sup(pmdl:pmodello);
{ effettua un riordinamento preliminare delle superfici }

var first,i,j,last:integer;
    t:plist_sup;

begin
{ SORT1 }
{ al termine del primo riordinamento le superfici saranno partizionate	}
{ in due insiemi A e B tali che qualsiasi superficie in A deve essere 	}
{ dipinta prima di qualsiasi superficie in B				}
   first:=1;
   last:=pmdl^.n_superfici;
   while (first<=last)
   do begin
      i:=1;
      while (i<=last)and not sup_copre(i,first,pmdl)
      do inc(i);
      if i<=last
	then inc(first)
	else begin
		swap_sup(first,last,pmdl);
		dec(last);
	     end
      end;

{ SORT2 }
{ Il secondo riordinamento opera sul sottoinsieme A ordinando 	}
{ le superfici che possono coprirsi. In presenza di relazioni	}
{ mutuamente ricorsive fra le superfici, il risultato non e'	}
{ corretto ( potrebbero verificarsi LOOPs )			}
        pmdl^.loop:=false;pmdl^.sup_coperte:=nil; {*loop*}
	first:=1;
	while (last>1) { change to: while (last<>first) }
	do begin
	   i:=first+1;
	   while (i<=last) and not sup_copre(i,first,pmdl)
	       do inc(i);
	   if i<=last
	   then begin
		  inc(first);
		  swap_sup(i,first,pmdl)
		end
	   else begin
		   swap_sup(first,last,pmdl);
		   if first>1
		   then begin
			dec(first);
			for i:=1 to first
			do if sup_copre(i,last,pmdl)
			     then begin
                                  {error('Loop detected');}
                                  new(pmdl^.sup_coperte);
                                  nsupc:=0;
                                  with pmdl^
                                  do begin
                                     for i:=1 to n_superfici
                                     do sup_coperte^[i]:=nil;
                                     for i:=1 to last
                                     do for j:=1 to last
                                        do if sup_copre(i,j,pmdl)
                                           then begin
                                                inc(nsupc);
                                                t:=sup_coperte^[i];
                                                new(sup_coperte^[i]);
                                                sup_coperte^[i]^.next:=t;
                                                sup_coperte^[i]^.sup:=j;
                                                end;
                                     end;
{$IFNDEF WINDOWS}
                                  write('Warning: Loop detected (',last);
                                  writeln(':',nsupc,')');
{$ENDIF}
                                  pmdl^.loop:=true; {*loop*}
                                  pmdl^._last:=last;
                                  exit;
                                  end;
			end;
		   dec(last);
		end;
	   end;
{ insert the following lines if the previous
  while-condition has been changed:
	while last>1
	do begin
		dec(first);
		for i:=1 to first
		do if sup_copre(i,last,mdl)
		     then error('Loop detected');
		dec(last);
	   end;	}

end; { of sort_sup }


procedure ConcaveToConvex(pol:pPolyCx;var normale:tpoint;pmdl:pmodello);
(* questa procedura suddivide un poligono concavo in
   piu' poligoni convessi                             *)
var v:integer;

   function IsConvex(pol:pPolyCx;var v:integer):boolean;
   var i:integer;
       a:tpoint;
   begin
      with pol^,pmdl^.PointArrayp^
      do if pol^.n_vertex > 3 (* un triangolo e' comunque convesso *)
         then begin
              for i:=1 to n_vertex-2
              do begin
                 cross(a,Vertici[Vertex[i]],Vertici[Vertex[i+1]],Vertici[Vertex[i+2]]);
                 if dot(a,Normale) > 0
                 then begin
                      v:=i+1;
                      IsConvex:=false;
                      exit;
                      end;
                 end;
              cross(a,Vertici[Vertex[n_vertex-1]],Vertici[Vertex[n_vertex]],Vertici[Vertex[1]]);
              if dot(a,Normale) > 0
              then begin
                   v:=n_vertex;
                   IsConvex:=false;
                   exit;
                   end;
              cross(a,Vertici[Vertex[n_vertex]],Vertici[Vertex[1]],Vertici[Vertex[2]]);
              if dot(a,Normale) > 0
              then begin
                   v:=1;
                   IsConvex:=false;
                   exit;
                   end;
              end;
   IsConvex:=true;
   end; { of IsConvex }

   procedure SplitConcave(pol:pPolyCx;v:integer);
   var i:integer;

      function Check(p1,p2:integer):boolean;
      var q1,q2:integer;

         function test(p1,p2,q1,q2:integer):boolean;
         var p:tpoint;
             p1p2,p1q1,p1q2:tpoint;
             pq1,pq2:real;
         begin
         with pol^,pmdl^.PointArrayp^
         do begin
              diff(p1p2,Vertici[Vertex[p2]],Vertici[Vertex[p1]]);
              crossv(p,normale,p1p2);
              diff(p1q1,Vertici[Vertex[q1]],Vertici[Vertex[p1]]);
              diff(p1q2,Vertici[Vertex[q2]],Vertici[Vertex[p1]]);
              pq1:=dot(p,p1q1);
              pq2:=dot(p,p1q2);
              test:=(abs(pq1)<epsilon2)or(abs(pq1)<epsilon2)
                     or((pq1>0) xor (pq2>0))
            end;
         end;

      begin
        Check:=false;
        with pol^,pmdl^
        do begin
           for q1:=1 to n_vertex
           do if (q1<>p1)and(q1<>p2)
              then begin
                   q2:=q1 mod n_vertex + 1;
                   if (q2<>p1)and(q2<>p2)
                   then if test(p1,p2,q1,q2)and test(q1,q2,p1,p2)
                        then exit; (* check:=false *)
                   end;
           end;
        Check:=true;
      end;

(* la funzione <check2> e' stata aggiunta per risolvere un bug *)
         function check2(p1,p2:integer):boolean;
         var p:tpoint;
             pp1,pm1:integer;
             p1p2,p1p,p1m:tpoint;
             pq1,pq2:real;
         begin
         with pol^,pmdl^.PointArrayp^
         do begin
              pp1:=p1 mod n_vertex + 1;
              if p1 = 1
              then pm1:=n_vertex
              else pm1:=p1-1;
              diff(p1p2,Vertici[Vertex[p2]],Vertici[Vertex[p1]]);
              diff(p1p,Vertici[Vertex[pp1]],Vertici[Vertex[p1]]);
              crossv(p,p1p,p1p2);
              check2:=dot(p,normale) > 0;
(*              diff(p1m,Vertici[Vertex[pm1]],Vertici[Vertex[p1]]);
              crossv(p,p1p2,p1m);
              if dot(p,normale) > 0
              then check2:=true;*)
            end;
         end;

      procedure Split(p1,p2:integer);
      var newpol:pPolyCx;
          t,i:integer;
      begin
        if p2 < p1
        then begin
               t:=p2;
               p2:=p1;
               p1:=t;
             end;
        new(newpol);
        newpol^.next:=pol^.next;
        pol^.next:=newpol;
        newpol^.n_vertex:=p2-p1+1; (*PolyCx*)
        for i:=p1 to p2
        do newpol^.vertex[i-p1+1]:=pol^.vertex[i];
        for i:=p2 to pol^.n_vertex
        do pol^.vertex[i-p2+p1+1]:=pol^.vertex[i];
        dec(pol^.n_vertex,p2-p1-1);
      end;

   begin
      with pol^,pmdl^
      do begin
           for i:=1 to n_vertex
           do if (i <> v)and(i <> v mod n_vertex+1)and(i mod n_vertex+1 <> v)
              then if Check2(v,i) and Check(i,v)
                   then begin
                        Split(i,v);
                        exit;
                        end;
         end;
      error('incorrect sequence of vertex');
   end;

begin
  while pol<>nil
  do if not IsConvex(pol,v)
     then SplitConcave(pol,v)
     else pol:=pol^.next;
end;

{procedure ConvertT2P(PolyCxs:pPolyCx;var ptr:pclass);
type pseg=^tseg;
     tseg=record
           a,b:word;
           next:pseg;
          end;
var t:pPolyCx;
    seg:pseg;
    i:integer;

  procedure StoreSegment(v2,v1:word);
  var t,p:pseg;
  begin
    t:=seg;p:=nil;
    while t<>nil
    do begin
       if (t^.a=v2)and(t^.b=v1)
       then begin
            if p=nil
            then begin
                 seg:=t^.next;
                 end
            else begin
                 p^.next:=t^.next;
                 end;
            dispose(t);
            exit;
            end;
       p:=t;
       t:=t^.next;
       end;

    new(t);
    t^.next:=seg;
    seg:=t;
    t^.a:=v1;
    t^.b:=v2;
  end;

  procedure BuildPoly;
  var k:word;
      qtr:pclass;
     procedure search;
     var t,p:pseg;
     begin
       t:=seg;p:=nil;
       while t<>nil
       do begin
          if t^.a=k
          then begin
               qtr:=ptr;
               new(ptr);
               ptr^.next:=qtr;
               ptr^.cont:=true;
               ptr^.vertice:=t^.b;
               k:=t^.b;
               if p=nil
               then begin
                    seg:=t^.next;
                    end
               else begin
                    p^.next:=t^.next;
                    end;
               dispose(t);
               exit;
               end;
          p:=t;
          t:=t^.next;
          end;
       writeln('Error in PolyCxs sequence');
       Halt;
     end;

  begin
    ptr:=nil;
    k:=seg^.a;
    while seg<>nil
    do search;
    ptr^.cont:=false;
  end;

begin
  t:=PolyCxs;
  seg:=nil;
  while t <> nil
  do with t^ do begin
       for i:=1 to n_vertex-1
       do StoreSegment(Vertex[i],Vertex[i+1]);
       StoreSegment(Vertex[n_vertex],Vertex[1]);
       t:=t^.next;
     end;
  BuildPoly
end; }

    procedure check(p:pclass;n_vertici:integer);
    begin
      while p <> nil
      do begin
         if p^.vertice >= n_vertici
         then error('not enough points are defined');
         p:=p^.next;
         end;
    end;

procedure store_model(pmdl:pmodello);
var i:integer;
    procedure storePoly(p:pclass;var pol:pPolyCx);
    begin
      new(pol);
      pol^.next:=nil;
      pol^.n_vertex:=0; (*PolyCx*)
      while p <> nil
      do begin
         inc(pol^.n_vertex);
         if pol^.n_vertex > zMaxPolyCxVertex
         then error('too many vertex in PolyCx');
         pol^.Vertex[pol^.n_vertex]:=p^.vertice;
         p:=p^.next;
         end;
    end;

begin
with pmdl^
do begin
{		if n_vertici < class^.n_vertici
        then error('wrong number of vertex');}
        for i:=1 to n_superfici
	do begin
              check(superfici[i],PointArrayp^.n_vertici);
              storePoly(superfici[i],list_PolyCxs[i]);
	      if not analisi_poligono(superfici[i],Normali[i],convessa[i],pmdl)
              then begin
                     error('inconsistent polygon');
                   end;
              ConcaveToConvex(list_PolyCxs[i],Normali[i],pmdl)
	   end;
	sort_sup(pmdl);
    end;
end;{ of store_model }

procedure init_model(var pmdl:pmodello;PointArray:pPointArray);
begin
 new(pmdl);
 with pmdl^
 do begin
       n_superfici:=0;
       PointArrayP:=PointArray;
       with PointArray^
       do extension:=distance(min,max)*0.5; (* non e' corretto ! *)
    end;
end;

procedure readfile(var p:pnode;dat_name:string);
{ classi ed oggetti  sono definiti nel file SIM.DAT			}
{ di tipo testo che ha il seguente formato: vedi il file 3D.TXT         }
var value:integer;
    s:string;
var linebuf:tlinebuf;  (*linebuf*)
    tid:tIdent;
    o_n_line_s:integer;
    o_save_s:string;
    entityp:pointer;
    pnext:pnode;
    break: boolean;

   procedure FetchGlobal;
   var p:pointer;
       value:integer;
       r,g,b:real;
       break: boolean;
   begin
       linebuf.assert('{');
       break:=false;
       repeat
       case linebuf.GetEntity(p,value) of
         null:error('unexpected end of file');
         keyword: case value of
                    zSky:    begin
                               linebuf.Get3RealNumber(r,g,b);
                               sky.r:=trunc(r*255);
                               sky.g:=trunc(g*255);
                               sky.b:=trunc(b*255);
                             end;
                    zGround: begin
                               linebuf.Get3RealNumber(r,g,b);
                               ground.r:=trunc(r*255);
                               ground.g:=trunc(g*255);
                               ground.b:=trunc(b*255);
                             end;
                    else error('unexpected element');
                    end; { of case }
         unknown: begin
                    linebuf.assert('}');
                    break:=true;
                  end;
         else error('unexpected element');
         end; { of case }
       until break;
   end;

begin {of readfile }
break:=false;
if pos('.',dat_name)=0
then dat_name:=dat_name+'.DAT';
linebuf.init(dat_name);
repeat
  tid:=linebuf.GetEntity(entityp,value);
  case tid of
    null:break:=true;
    keyword:if value = zGlobal
            then FetchGlobal
            else error('unexpected element');
    unknown:begin
              linebuf.GetElement(s);
              if s='#'
              then begin
                   linebuf.assert('INCLUDE');
                   if linebuf.GetElement(s)=prolinea.strings
                   then begin
                        o_n_line_s:=n_line_s;
                        o_save_s:=save_s;
                        readfile(p,s);
                        n_line_s:=o_n_line_s;
                        save_s:=o_save_s;
                        end
                   else error('"filename" expected');
                   end
              else error('Unexpected element');
            end;
    objects:
               begin
               if p = nil
               then begin
                    p:=entityp;
                    pnext:=p
                    end
               else begin
                    pnext^.next:=entityp;
                    pnext:=pnext^.next
                    end;
               end;
    material: linebuf.currentMaterial:=entityp;
    coordinate: linebuf.currentPointArray:=entityp;
    light: begin
             pLight(entityp)^.next:=CurrentLight;
             currentLight:=entityp;
           end;
    else error('unexpected element');
    end;
until break;
linebuf.done;
end; {of readfile }



function tLineBuf.fetch_object:pnode;
var p:pnode;
    q:pointer;
    value:integer;
    lastChild:pnode;
    tid:tident;
    break:boolean;

begin
  new(p);
  with p^
  do begin
       next:=nil;
       state:=CurrentState;
       attivo:=true;
       typenode:=structure;
       child:=nil;
     end;
  assert('{');
  break:=false;
  repeat
    tid:=GetEntity(q,value);
    case tid of
      null:error('unexpected end of file');
      objects:
                 begin
                 if p^.child = nil
                 then begin
                      p^.child:=q;
                      lastChild:=p^.child
                      end
                 else begin
                      lastChild^.next:=q;
                      lastChild:=lastChild^.next
                      end;
                 end;
      material: currentMaterial:=q;
      coordinate: currentPointArray:=q;
      light: begin
               pLight(q)^.next:=CurrentLight;
               currentLight:=q;
             end;
      unknown: begin
                 assert('}');
                 break:=true;
               end;
      else error('unexpected element');
      end; { of case }
  until break;
  fetch_object:=p;
  CurrentState:=p^.state; (* restore old state *)
end;

function tLinebuf.GetEntity(var entityp:pointer;var value:integer):tIdent;
label continue;
var s,name:string;
    unreadname:boolean;
    element:telement;
    tid:tident;
    id:integer;
    IsTypeDef,skip:boolean;

    procedure skip_unknown;
    var s:string;
    begin
      assert('{');
      while (GetElement(s) <> none) and (s <> '}')
      do ;
    end;

begin
  repeat
  skip:=false;
  unreadname:=false;
  entityp:=nil;
  element:=GetElement(s);
  IsTypeDef:=false;
  if (element = identifier) (* look for 'def' *)
  then begin
         id:=ident.search(s,tid);
         if (tid = keyword) and
            ((ident.table[id].value=zDef) or (ident.table[id].value=zTypeDef))
         then begin
              IsTypeDef:=(ident.table[id].value=zTypeDef);
              if GetElement(name) <> identifier
              then error('identifier expected');
              unreadname:=true;
              element:=GetElement(s);
              end;
       end;
  case element of
    identifier:begin
                 id:=ident.search(s,tid); (* id <> -1 *)
                 case tid of
                   keyword:
                     begin
                       value:=ident.table[id].value;
                       case value of
                         zStructure, zMaterial, zDirectionalLight, zCoordinate3, zTransform,
                         zIndexedLineSet,zIndexedFaceSet:
                           begin
                             case ident.table[id].value of
                               zStructure: begin
                                            entityp:=fetch_object;
                                            tid:=objects;
                                          end;
                               zMaterial: begin
                                            entityp:=fetch_material;
                                            tid:=material;
                                          end;
                               zDirectionalLight:begin
                                            entityp:=fetch_directlight;
                                            tid:=light;
                                          end;
                               zTransform: begin (* this is not an entity *)
                                            fetch_transform;
                                            skip:=true;
                                            (* sorry for the 'goto', but Turbo Pascal for Windows
                                               does not support the statement 'continue' *)
                                            goto continue;
                                           end;
                               zCoordinate3:begin
                                            entityp:=fetch_coordinate;
                                            tid:=coordinate;
                                          end;
                               zIndexedLineSet:begin
                                            entityp:=fetch_indexedset(lineset);
                                            tid:=objects;
                                          end;
                               zIndexedFaceSet:begin
                                            entityp:=fetch_indexedset(faceset);
                                            tid:=objects;
                                          end;
                               end; { of case }
                             if unreadname
                             then begin
                                  with ident
                                  do table[add(name,tid)].entityp:=entityp;
                                  unreadname:=false;
                                  end;
                             GetEntity:=tid;
                           end;
                         else GetEntity:=keyword;
                       end; { of case value }
                     end;
                   objects: begin (* objects must be duplicated *)
                              GetEntity:=tid;
                              duplicatetree(ident.table[id].entityp,pnode(entityp));
                              with pnode(entityp)^ do
                              begin
                                 attivo:=true;
                                 next:=nil;
                                 (* modifica la scala *)
                                 set_scale(entityp,currentState.scala);
                                 with currentState
                                 do set_rotation2(entityp,cs,sn);
                                 with currentState
                                 do set_position(entityp,posizione);
                              end;
                            end;
                   light,
                   coordinate,
                   material: begin
                              entityp:=ident.table[id].entityp;
                              GetEntity:=tid;
                             end;
                   unknown: begin
{$IFNDEF WINDOWS}
                              writeln('Warning: unknown entity');
{$ENDIF}
                              skip:=true;
                              skip_unknown;
                            end;
                 end; { of case tid }
               end;
    none:GetEntity:=null;
    else begin
         GetEntity:=unknown;
         if not ForgetElement
         then error('internal error in parser');
         if unreadname
         then error('a def must be followed by an entity');
         end;
    end; (* of case element *)
continue:
  until (not IsTypeDef)and (not skip);
end;

function tLinebuf.fetch_material:pMaterial;
var p:pMaterial;
    q:pointer;
    value:integer;
    r,g,b:real;col:colore;
    break:boolean;
begin
  assert('{');
  new(p);p^:=defaultMaterial^;
  break:=false;
  repeat
  case GetEntity(q,value) of
      null:error('unexpected end of file');
      keyword: case value of
                 zDiffuseColor,zEmissiveColor,zAmbientColor,zSpecularColor:
                    begin
                      Get3RealNumber(r,g,b);
                      col.r:=trunc(r*255);
                      col.g:=trunc(g*255);
                      col.b:=trunc(b*255);
                      case value of
                        zDiffuseColor:p^.DiffuseColor:=col;
                        zEmissiveColor:p^.EmissiveColor:=col;
                        zAmbientColor:p^.AmbientColor:=col;
                        zSpecularColor:p^.SpecularColor:=col;
                        end;
                    end
                 else error('unexpected element');
               end;
      unknown: begin
                 assert('}');
                 break:=true;
               end;
      else error('unexpected element');
      end; { of case }
  until break;
  fetch_material:=p;
end;

function tLinebuf.fetch_indexedset(tipo1:ttypenode):pnode;
var q:pointer;
    value:integer;
    p:pnode;
    classe:pclass;

    procedure store_set(classe:pclass);

       procedure StoreSurface(pc:pclass);
       var qc:pclass;
       begin
        with p^.tipo^
        do begin
            classe:=nil; (*??*)
            while pc <> nil
            do begin
               inc(n_superfici);
               if n_superfici > n_max_superfici
               then error('Too many surfaces');
               colori[n_superfici]:=currentMaterial;
               superfici[n_superfici]:=pc;
               while (pc <> nil) and (pc^.cont)
               do pc:=pc^.next;
               if pc <> nil
               then begin
                    qc:=pc;
                    pc:=pc^.next;
                    qc^.next:=nil;
                    end
               end;
           end;
       end;

    begin
      if currentPointArray = nil
      then error('coordinate3 is missing');
      new(p);
      p^.typenode:=tipo1;
      with p^, state do
      begin
         attivo:=true;
         next:=nil;
         state:=currentState;
(* NOTA NOTA NOTA NOTA NOTA NOTA NOTA NOTA NOTA NOTA NOTA NOTA NOTA NOTA    *)
(* gestione provvisoria di piu' faceset appartenenti allo stesso PointArray *)
(* la variabile <attivo> non dovrebbe essere usata per questo scopo !!!     *)
         if (typenode = faceset)
         then begin
              if currentPointArray^.pmastermdl = nil
              then begin
                   init_model(tipo,currentPointArray);
                   currentPointArray^.pmastermdl:=tipo
                   end
              else begin
                   attivo:=false;
                   tipo:=currentPointArray^.pmastermdl
                   end;
              StoreSurface(classe);
              store_model(tipo);
              end
         else begin
              new(line);
              with line^
              do begin
                    n_superfici:=0; (*??*)
                    PointArrayP:=currentPointArray;
                    with currentPointArray^
                    do extension:=distance(min,max)*0.5; (* non e' corretto ! *)
                    colori[1]:=currentMaterial;
                 end;
              line^.classe:=classe;
              file3d.check(classe, currentPointArray^.n_vertici);
              end;
      end;
    end;

   procedure read_set(var classe:pclass);
   var qc:pclass;
      value:integer;
      s:string;
      code:integer;
      break: boolean;
   begin
     classe:=nil;
     qc:=nil;
     Assert('[');
     break:=false;
     while (not break) and (GetElement(s) <> none)
     do if s=']'
        then begin
   	      if qc<>nil then qc^.cont:=false;
              break:=true;
             end
        else if s=','
             then qc^.cont:=false
             else begin
                  val(s,value,code);
                  if code <> 0
                  then error('number expected');
                  if value >= n_max_vertici
                  then error('Vertex overflow');
                  if classe=nil
                  then begin
                         new(classe);
                         qc:=classe;
                       end
                  else begin
                       new(qc^.next);
                       qc:=qc^.next;
                       end;
                  qc^.next:=nil;
	          qc^.vertice:=value;
	          qc^.cont:=true;
                  end;
   end;

begin
 assert('{');
 if (GetEntity(q,value) = keyword) and (value = zcoordIndex)
 then begin
        read_set(classe);
        store_set(classe);
        assert('}');
      end
 else error('coordIndex[] expected');
 fetch_indexedset:=p;
end;

function tLinebuf.fetch_coordinate:pPointArray;
var p:pPointArray;
    q:pointer;
    value:integer;
    r,g,b:real;col:colore;

   procedure store_point(var p:pPointArray);
   var i:integer;
       s:string;

          procedure minmax(var x,xmin,xmax:real);
          begin
          if x > xmax
          then xmax:=x
          else if x < xmin
	       then xmin:=x
          end; { of minmax }

   begin
   new(p);
   with p^
   do begin
          pmastermdl:=nil;
          n_vertici:=0;
          Assert('[');
          repeat
	       with vertici[n_vertici]
	       do begin
                  Get3RealNumber(x,y,z);
                  if n_vertici = 0
                  then begin
		       min.x:=x;max.x:=x;
		       min.y:=y;max.y:=y;
		       min.z:=z;max.z:=z;
                       end
                  else begin
		       minmax(x,min.x,max.x);
		       minmax(y,min.y,max.y);
		       minmax(z,min.z,max.z);
		     end;
                  end;
               inc(n_vertici);
               until (GetElement(s)=none)or(s=']');
               with middle
	       do begin
		    x:=(min.x+max.x)/2;
		    y:=(min.y+max.y)/2;
		    z:=(min.z+max.z)/2;
	          end;

     end;
   end;{ of store_point }


begin
  assert('{');
  p:=nil;
  if (GetEntity(q,value) = keyword) and (value = zPoint)
  then begin
         store_point(p);
         assert('}');
       end
  else error('point[] expected');
  fetch_coordinate:=p;
end;

function tLinebuf.fetch_directlight:pLight;
var p:pLight;
    q:pointer;
    value:integer;
    r,g,b:real;
    break:boolean;
begin
  assert('{');
  new(p);
  with p^
  do with color,dir
     do begin
          r:=255;g:=255;b:=255;
          x:=0;y:=0;z:=-1;
        end;
  break:=false;
  repeat
  case GetEntity(q,value) of
      null:error('unexpected end of file');
      keyword: case value of
                 zColor:
                    begin
                      Get3RealNumber(r,g,b);
                      p^.color.r:=trunc(r*255);
                      p^.color.g:=trunc(g*255);
                      p^.color.b:=trunc(b*255);
                    end;
                 zDirection:
                    begin
                      Get3RealNumber(p^.dir.x,p^.dir.y,p^.dir.z);
                    end;
                 else error('unexpected element');
               end; { of case }
      unknown: begin
                 assert('}');
                 break:=true;
               end;
      else error('unexpected element');
      end; { of case }
  until break;
  versore(p^.dir);
  fetch_directlight:=p;
end;

procedure tLinebuf.fetch_transform;
var q:pointer;
    value:integer;
    temp,rot_xy,dx,dy,dz,dscale:real;
    break:boolean;
begin
  assert('{');
  break:=false;
  repeat
  case GetEntity(q,value) of
      null:error('unexpected end of file');
      keyword: case value of
                 zTranslation: with CurrentState,posizione
                               do begin
                                    Get3RealNumber(dx,dy,dz);
                                    x:=x+(dx*cs-dy*sn)*scala;
                                    y:=y+(dy*cs+dx*sn)*scala;
                                    z:=z+dz*scala;
                               end;
                 zRotation: begin
                              Get3RealNumber(rot_xy,temp,temp);
                              with CurrentState
                              do begin
                                 temp:=cs;
	                         cs:=temp*cos(rot_xy)-sn*sin(rot_xy);
	                         sn:=temp*sin(rot_xy)+sn*cos(rot_xy);
                                 end;
                            end;
                 zScale:    begin
                              Get3RealNumber(dscale,temp,temp);
                              CurrentState.scala:=dscale*CurrentState.scala;
                            end;
                 else error('unexpected element');
               end; { of case }
      unknown: begin
                 assert('}');
                 break:=true;
               end;
      else error('unexpected element');
      end; { of case }
  until break;
end;

begin
define_comment('''',#0);
string_is('"');
ident.init(zIdentBufSize);
ident.storevalue('DEF',keyword,zDef);
ident.storevalue('INDEXEDLINESET',keyword,zIndexedLineSet);
ident.storevalue('INDEXEDFACESET',keyword,zIndexedFaceSet);
ident.storevalue('COORDINDEX',keyword,zCoordIndex);
ident.storevalue('STRUCTURE',keyword,zStructure);
ident.storevalue('GLOBAL',keyword,zGlobal);
ident.storevalue('TRANSLATION',keyword,zTranslation);
ident.storevalue('ROTATION',keyword,zRotation);
ident.storevalue('SCALE',keyword,zScale);
ident.storevalue('POINT',keyword,zPoint);
ident.storevalue('MATERIAL',keyword,zMaterial);
ident.storevalue('COLOR',keyword,zColor);
ident.storevalue('SKY',keyword,zSky);
ident.storevalue('GROUND',keyword,zGround);
ident.storevalue('DIRECTION',keyword,zDirection);
ident.storevalue('DIRECTIONALLIGHT',keyword,zDirectionalLight);
ident.storevalue('AMBIENTCOLOR',keyword,zAmbientColor);
ident.storevalue('DIFFUSECOLOR',keyword,zDiffuseColor);
ident.storevalue('SPECULARCOLOR',keyword,zSpecularColor);
ident.storevalue('EMISSIVECOLOR',keyword,zEmissiveColor);
ident.storevalue('TYPEDEF',keyword,zTypeDef);
ident.storevalue('COORDINATE3',keyword,zCoordinate3);
ident.storevalue('TRANSFORM',keyword,zTransform);
end.