unit prolinea;

(* Versione 0.2, questa versione e' incompleta e non e' provata !!! *)
(* rev 0.1: l'oggetto <multi> usa variabili dinamiche invece di array *)
(* rev 0.2: introdotto l'oggetto <linebuffer>, utile per leggere i files
            che devono essere interpretati da un programma *)

(* E' ancora da definire il campo di applicazione del carattere stringa
   e del carattere  commento!!!*)

(* Unit per l' analisi di un file di tipo line-oriented *)

(* Le procedure definite nella unit analizzano una stringa che
   normalmente e' la generica linea di un file di tipo testo *)

(* L'analisi di un file 'line-oriented' si puo' avvalere delle seguenti
   units: PROLINEA, HASH, SORT *)
interface
{$IFDEF WINDOWS}
uses wobjects;
{$ELSE}
uses objects;
{$ENDIF}
(* ------------- TIPI ------------- *)
(* Il tipo <multi> permette la gestione veloce/efficiente di una lista di
   stringhe *)
type pstring=^string;
type pmulti=^multi;
     multi=object
             function count:word;
             function str(i:word):pstring;
             constructor init(bufsize:word);
             destructor done;
             function add(st:string):integer;
             function search(st:string):integer;
           private
             pbuff:pointer;
             free:longint;
             pidx:pcollection;
             freeidx:pstring;
           end;

(* Il tipo <linebuffer> permette una gestione elementare di un file
   line-oriented *)
type tElement=(none,identifier,symbol,number,strings);
type tlinebuffer=object
                   procedure Flush(var s:string;var eof:boolean);virtual;
                   function GetElement(var s:string):tElement;
                   function ForgetElement:boolean;
                   constructor Init;
                   destructor Done;
                 private
                   str:string;
                   strp,savedp:integer;
                   comment:boolean;
                 end;

(* ------------- PROCEDURE GLOBALI ------------- *)
  procedure define_comment(begin_comment,end_comment:char);
(* la procedura <define_comment> definisce i delimitatori di
    un commento. Se <end_comment>=#0 allora i commenti terminano
    alla fine della linea corrente.
*)
  procedure comment_is(ch:char); (* obsolete *)
(* procedure comment_is(ch:char); Definisce il carattere
   che inizia un commento, per esempio comment_is(';') *)

  procedure string_is(ch:char);
(* procedure string_is(ch:char);  Definisce il carattere
   che delimita una stringa, per esempio string_is('"') *)

(* procedure? macrodef(mname:char?;mrule:string); Definisce una macro che
   puo' essere richiamata in una regola *)

(* ------------- PROCEDURE LOCALI ------------- *)
procedure strip(var s:string);
(* procedure strip(var s:string); Rimuove i caratteri ' ' non significativi
   da una stringa <s> *)

procedure split(s:string;sep:char;pms:pmulti);
(* procedure split(s:string;sep:char;pms:pmulti); Suddivide una
   stringa <s> in piu' componenti separandoli mediante il separatore <sep>
   e rimuovendo sia i caratteri ' ' in testa ed in coda ad ogni componente.
   Inoltre se l'ultima componente e' nulla, questa non viene memorizzata. *)

function fsplit(s,rule:string;pms:pmulti):boolean;
(* function fsplit(s,rule:string;pms:pmulti):boolean; Suddivide una
   stringa <s> in piu' componenti utilizzando la regola <rule>,
   ritorna il valore <false> se non e' possibile applicare la regola.
   La regola puo' contenere: caratteri normali, %w (identificatore),
   %s (stringa generica), %b (un numero qualsiasi di blank), %% (%).
   La regola %s seguita da carattere ha un significato particolare. *)

procedure UpCases(var s:string);
(* procedure UpCases(var s:string); cambia i caratteri della stringa <s>
   in formato maiuscolo *)

implementation

  var string_is_def,comment_is_def:boolean;
      string_is_char,begin_comment_char,end_comment_char:char;

  procedure Error(err:word);
  begin
  writeln('Fatal error ',err);
  halt;
  end;

(* ----------- <multi> -------------*)

  function multi.str(i:word):pstring;
  begin
    str:=pidx^.at(i)
  end;

  constructor multi.init;
  begin
    free:=bufsize;
    New(pidx,Init(10,5));
    GetMem(pbuff,bufsize);
    freeidx:=pbuff;
  end;

  destructor multi.done;
  begin
    pidx^.deleteall;
    dispose(pidx,done);
  end;

  function multi.count:word;
  begin
    count:=pidx^.count;
  end;


  function multi.add(st:string):integer;
  begin
    add:=pidx^.count;
    pidx^.insert(freeidx);
    dec(free,length(st)+1);
    if free < 0
    then Error(113);
    move(st,freeidx^,length(st)+1);
    inc(longint(freeidx),length(st)+1);
  end;

  function multi.search(st:string):integer;
  (* questa funzione determina se la parte iniziale di <St> include
     una stringa memorizzata in <multi>. In caso negativo restituisce -1.
  *)

  var j,keyidx,keylen:integer;
      found:boolean;
      ps:pstring;
  begin
    search:=-1;
    found:=false;
    if st=''
    then exit;
    keyidx:=0;
    while not found and (keyidx < pidx^.count)
    do begin
       ps:=pidx^.at(keyidx);
       keylen:=length(ps^);
       if (keylen=length(st))and(pos(ps^,st) = 1)
       then begin
            found:=true;
            search:=keyidx;
            end;
       inc(keyidx);
       end;
  end;

(* ----------- <linebuffer> -------------*)
  procedure tLineBuffer.Flush(var s:string;var eof:boolean);
  begin
    RunError(211); (* ABSTRACT METHOD: must be overriden *)
  end;

  function tLineBuffer.ForgetElement:boolean;
  begin
    ForgetElement:=savedp <> -1;
    if savedp <> -1
    then strp:=savedp;
  end;

  function tLineBuffer.GetElement(var s:string):tElement;
  var eof:boolean;
      i:integer;

      procedure SkipBlanks;
      (* questa procedura salta gli spazi, i caratteri speciali ed i commenti *)
      begin
        if comment_is_def
        then if comment
             then if end_comment_char = #0
                  then begin
                         strp:=length(str)+1;
                         comment:=false;
                       end
                  else while (strp<=length(str)) and (str[strp]<>end_comment_char)
                       do inc(strp);
        while (strp<=length(str)) and (str[strp]<=' ')
        do inc(strp);
        if comment_is_def and (strp<=length(str))
        then if comment
             then begin
                  if str[strp]=end_comment_char
                  then begin
                       inc(strp);
                       comment:=false;
                       SkipBlanks; (* chiamata ricorsiva...*)
                       end
                  end
             else if str[strp]=begin_comment_char
                  then begin
                       inc(strp);
                       comment:=true;
                       SkipBlanks; (* chiamata ricorsiva...*)
                       end;
      end;

      procedure FetchDigits;
      begin
           inc(i);
           s[i]:=str[strp];
           inc(strp);
           while (strp<=length(str))and(str[strp] in ['0'..'9'])
           do begin
                inc(i);
                s[i]:=str[strp];
                inc(strp);
              end;
      end;
  begin
      savedp:=-1;
      eof:=false;
      SkipBlanks;
      while ((length(str)=0) or (strp>length(str)))and not eof
      do begin
           Flush(str,eof);
           strp:=1;
           SkipBlanks;
         end;
(* Check if there is an element *)
      if strp > length(str)
      then begin
           s:='';
           GetElement:=none;
           exit;
           end;
(* Check if the element is an identifier *)
      if str[strp] in ['A'..'Z','a'..'z']
      then begin
           i:=1;savedp:=strp;
           s[i]:=str[strp];
           inc(strp);
           while (strp<=length(str))and(str[strp] in ['A'..'Z','a'..'z','0'..'9','_'])
           do begin
                inc(i);
                s[i]:=str[strp];
                inc(strp);
              end;
           s[0]:=char(i);
           GetElement:=identifier;
           exit;
           end;
(* Check if the element is a delimited string *)
      if string_is_def and (str[strp]=string_is_char)
      then begin
           i:=0;savedp:=strp;
           inc(strp);
           while (strp<=length(str))and(str[strp] <> string_is_char)
           do begin
                inc(i);
                s[i]:=str[strp];
                inc(strp);
              end;
           inc(strp);
           s[0]:=char(i);
           GetElement:=strings;
           exit;
           end;
(* Check if the element is number *)
      i:=0;
      if (strp < length(str)) and (str[strp] in ['+','-'])
         and (str[strp+1] in ['0'..'9'])
      then begin
           i:=1;savedp:=strp;
           s[i]:=str[strp];
           inc(strp);
           end;
      if str[strp] in ['0'..'9']
      then begin
           if savedp = -1
           then savedp:=strp;
           FetchDigits;
           if (strp < length(str)) and (str[strp]='.')
           then FetchDigits;
           if (strp < length(str)) and (upcase(str[strp])='E')
           then begin
                if (strp+1 < length(str)) and (str[strp+1] in ['+','-'])
                   and (str[strp+2] in ['0'..'9'])
                then begin
                     inc(i);
                     s[i]:=str[strp];
                     inc(strp);
                     FetchDigits;
                     end
                else if str[strp+1] in ['0'..'9']
                     then FetchDigits;
                end;
           s[0]:=char(i);
           GetElement:=number;
           exit;
           end;
(* Check if the element is a symbol *)
      s:=str[strp];savedp:=strp;
      inc(strp);
      GetElement:=symbol;
  end;

  constructor tLineBuffer.Init;
  begin
    str:='';strp:=1;
    savedp:=-1;
    comment:=false;
  end;

  destructor tLineBuffer.Done;
  begin
  end;

(* ----------- <PROCEDURES> -------------*)

  procedure split(s:string;sep:char;pms:pmulti);
  var i,j:integer;
      sub:string;
      skip_string,exit_loop:boolean;
  begin
  i:=1;
  exit_loop:=false;
  while (i<=length(s))and not exit_loop
  do begin
     j:=0;
     while (i<=length(s))and(s[i]=' ') (* Remove leading blanks *)
     do inc(i);
     while (i<=length(s))and(s[i]<>sep)and not exit_loop
     do if comment_is_def and (s[i]=begin_comment_char)
        then exit_loop:=true
        else begin
             inc(j);
             sub[j]:=s[i];
             skip_string:=string_is_def and(s[i]=string_is_char);
             inc(i);
             if skip_string
             then repeat
                    inc(j);
                    sub[j]:=s[i];
                    inc(i);
                  until (i=length(s))or(sub[j]=string_is_char);
             end;
     (*if i<=length(s) then *)
     inc(i); (* skip separator *)
     while (j>0)and(sub[j]=' ') (* Remove trailing blanks *)
     do dec(j);
     sub[0]:=char(j);
     pms^.add(sub);
     end;
  end;


  procedure string_is(ch:char);
  begin
    string_is_def:=true;
    string_is_char:=ch;
  end;

  procedure define_comment(begin_comment,end_comment:char);
  begin
    comment_is_def:=true;
    begin_comment_char:=begin_comment;
    end_comment_char:=end_comment;
  end;

  procedure comment_is(ch:char);
  begin
    define_comment(ch,ch);
  end;


  procedure strip(var s:string);
  var i,j:integer;
      blank:boolean;
  begin
  blank:=true;  (* -->remove leading blank *)
  j:=0;i:=1;
  while (i<=length(s))
  do begin
     if s[i]=' '
     then if blank
          then { nothing }
          else begin
               blank:=true;
               inc(j);
               s[j]:=s[i];
               end
     else begin
          if string_is_def and(s[i]=string_is_char)
          then repeat
                 inc(j);
                 s[j]:=s[i];
                 inc(i);
               until (i=length(s))or(s[i]=string_is_char);
          if blank
          then blank:=false;
          inc(j);
          s[j]:=s[i];
          end;
     inc(i);
     end;
  if (j<>0)and(s[j]=' ')
  then dec(j); (* -->remove trailing blank *)
  s[0]:=char(j);
  end;


function fsplit(s,rule:string;pms:pmulti):boolean;
var i,ir:integer;
    sub:string;
    correct:boolean;

  procedure skipblanks;
  begin
    while (i<=length(s))and(s[i]=' ') (* Remove leading blanks *)
    do inc(i);
  end;

  function xword:boolean;
  var j:integer;
  begin
     skipblanks;
     if (i>length(s))
     then begin
          xword:=false;
          exit;
          end;
     j:=0;
     while (i<=length(s))and(s[i]in['0'..'9','a'..'z','A'..'Z','_'])
     do begin
          inc(j);
          sub[j]:=s[i];
          inc(i);
        end;
     sub[0]:=char(j);
     pms^.add(sub);
     skipblanks;
     xword:=(j<>0);
  end;

  function xstring:boolean;
  var j:integer;
      skip_string:boolean;
      stop_ch:set of char;
  begin
     j:=0;
     if comment_is_def
     then stop_ch:=[begin_comment_char]
     else stop_ch:=[#0]; (* si assume non presente in un file di tipo testo *)
     if (ir<length(rule))and(rule[ir+1]<>'%')
     then stop_ch:=stop_ch+[rule[ir+1]];
     while (i<=length(s))and not(s[i] in stop_ch)
     do begin
          inc(j);
          sub[j]:=s[i];
          skip_string:=string_is_def and(s[i]=string_is_char);
          inc(i);
          if skip_string
          then repeat
                 inc(j);
                 sub[j]:=s[i];
                 inc(i);
               until (i=length(s))or(sub[j]=string_is_char);
          end;
     sub[0]:=char(j);
     pms^.add(sub);
     xstring:=true;
  end;

  begin
  i:=1;ir:=1;correct:=true;
  skipblanks;
  while (ir<=length(rule))and correct
  do begin
     if (rule[ir]='%')and(ir<length(rule))
     then begin
          inc(ir);
          case rule[ir] of
            'w':correct:=xword(*s,i,ms*);
            'b':begin
                correct:=true;
                skipblanks;
                end;
            's':correct:=xstring(*s,i,ms*);
            '%':if (i<=length(s))
                then begin
                     correct:=s[i]=rule[ir];
                     inc(i);
                     end
                else correct:=false;
            else error(113);
            end; { of case }
          inc(ir);
          end
     else begin
          correct:=s[i]=rule[ir];
          inc(ir);inc(i);
          end;
     end;
  if correct
  then if (i>length(s))
       then fsplit:=(ir>length(rule))
       else fsplit:=comment_is_def and (s[i]=begin_comment_char)
  else fsplit:=false;
  end;

procedure UpCases(var s:string);
var i:integer;
begin
  for i:=1 to length(s)
  do s[i]:=UpCase(s[i]);
end;

begin
(* ------------- INIZIALIZZAZIONI ------------- *)
string_is_def:=false;comment_is_def:=false;
end.


(*DEMO: segue una demo per l'uso di PROLINEA.PAS*)
var s:string;z:pmulti;i:integer;
const buffsize=512; (* room for strings in <multi> *)

begin
string_is('"');comment_is('\');
s:='function fsplit(s,rule:string;pms:pmulti):boolean; \commento';
writeln;
writeln(s);
writeln;
new(z,init(buffsize));
(* formatted split demo *)
writeln(fsplit(s,'%bfunction%w(%s)%b:%w;%b',z));
for i:=0 to z^.count-1
do write('<',z^.str(i)^,'>');
dispose(z,done);
writeln;
(* unformatted split demo *)
new(z,init(buffsize));
split(s,';',z);
for i:=0 to z^.count-1
do write('<',z^.str(i)^,'>');
dispose(z,done);
writeln;
string_is('"');
s:='Questi     spazi    sono   compressi , "   questi   invece    no",   questi  s      .';
strip(s);
writeln(s);
end.
